// vctestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "vctest.h"
#include "vctestDlg.h"
#include "resource.h"
#include <atlbase.h>
#include ".\vctestdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVctestDlg dialog

CVctestDlg::CVctestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVctestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVctestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVctestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVctestDlg)
	DDX_Control(pDX, IDC_VITAMINCTRL1, m_vitCtrl1);
	DDX_Control(pDX, IDC_VITAMINCTRL2, m_vitCtrl2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVctestDlg, CDialog)
	//{{AFX_MSG_MAP(CVctestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_COMBO_SERVER_TYPE, OnSelchangeComboServerType)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUT_DO_SET, OnButDoSet)
	ON_BN_CLICKED(IDC_BUT_DI_GET, OnButDiGet)
	ON_BN_CLICKED(IDC_BUT_4CH_DOSET1, OnBut4chDoset1)
	ON_BN_CLICKED(IDC_BUT_4CH_DOSET2, OnBut4chDoset2)
	ON_BN_CLICKED(IDC_BUT_4CH_DI1, OnBut4chDi1)
	ON_BN_CLICKED(IDC_BUT_4CH_DI2, OnBut4chDi2)
	ON_BN_CLICKED(IDC_BUT_4CH_DI3, OnBut4chDi3)
	ON_BN_CLICKED(IDC_BUT_4CH_DI4, OnBut4chDi4)
	ON_BN_CLICKED(IDC_CHK_VIDEO, OnChkVideo)
	ON_CBN_SELCHANGE(IDC_COMBO_VIDEODEC_FMT, OnSelchangeComboVideodecFmt)
	ON_EN_CHANGE(IDC_EDIT_JPEGQ, OnChangeEditJpegq)
	ON_BN_CLICKED(IDC_BUT_UP, OnButUp)
	ON_BN_CLICKED(IDC_BUT_LEFT, OnButLeft)
	ON_BN_CLICKED(IDC_BUT_HOME, OnButHome)
	ON_BN_CLICKED(IDC_BUT_RIGHT, OnButRight)
	ON_BN_CLICKED(IDC_BUT_DOWN, OnButDown)
	ON_BN_CLICKED(IDC_BUT_TELE, OnButTele)
	ON_BN_CLICKED(IDC_BUT_WIDE, OnButWide)
	ON_BN_CLICKED(IDC_BUT_FAR, OnButFar)
	ON_BN_CLICKED(IDC_BUT_NEAR, OnButNear)
	ON_BN_CLICKED(IDC_BUT_AUTO, OnButAuto)
	ON_BN_CLICKED(IDC_BUT_PAN, OnButPan)
	ON_BN_CLICKED(IDC_BUT_PATROL, OnButPatrol)
	ON_BN_CLICKED(IDC_BUT_PTSTOP, OnButPtstop)
	ON_BN_CLICKED(IDC_BUTTON_CONN, OnButtonConn)
	ON_BN_CLICKED(IDC_CHECK_AUTO_RECONNECT, OnCheckAutoReconnect)
	ON_CBN_SELCHANGE(IDC_COMBO_STREAM_OPT, OnSelchangeComboStreamOpt)
	ON_CBN_SELCHANGE(IDC_COMBO_PROTOCOL, OnSelchangeComboProtocol)
	ON_BN_CLICKED(IDC_CHECK_MOEDIT, OnCheckMoedit)
	ON_BN_CLICKED(IDC_CHECK_AUDIO, OnCheckAudio)
	ON_CBN_SELCHANGE(IDC_COMBO_QUALITY, OnSelchangeComboQuality)
	ON_CBN_SELCHANGE(IDC_COMBO_VSIZE, OnSelchangeComboVsize)
	ON_CBN_SELCHANGE(IDC_COMBO_CHANNEL, OnSelchangeComboChannel)
	ON_BN_CLICKED(IDC_CHECK_FORCE_GDI, OnCheckForceGdi)
	ON_BN_CLICKED(IDC_CHECK_GDI_STRETCHBLT, OnCheckGdiStretchblt)
	ON_BN_CLICKED(IDC_CHECK_DDRAW_ONEPASS, OnCheckDdrawOnepass)
	ON_BN_CLICKED(IDC_CHECK_IGNORE_BORDER, OnCheckIgnoreBorder)
	ON_BN_CLICKED(IDC_CHECK_IGNORE_CAPTION, OnCheckIgnoreCaption)
	ON_BN_CLICKED(IDC_CHECK_DEBLOCK, OnCheckDeblock)
	ON_BN_CLICKED(IDC_CHECK_DISPLAY, OnCheckDisplay)
	ON_BN_CLICKED(IDC_CHECK_ZOOM_EDIT, OnCheckZoomEdit)
	ON_BN_CLICKED(IDC_CHECK_ZOOM_ENABLED, OnCheckZoomEnabled)
	ON_BN_CLICKED(IDC_CHECK_USERDATE, OnCheckUserdate)
	ON_BN_CLICKED(IDC_CHECK_STRETCH, OnCheckStretch)
	ON_CBN_SELCHANGE(IDC_COMBO_USR_TIMEFMT, OnSelchangeComboUsrTimefmt)
	ON_BN_CLICKED(IDC_BUT_BROWSE, OnButBrowse)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_BUT_SEND_COMCMD, OnButSendComcmd)
	ON_BN_CLICKED(IDC_BUT_READ_COMCMD, OnButReadComcmd)
	ON_BN_CLICKED(IDC_BUTTON_DBPATH_BROWSE, OnButtonDbpathBrowse)
	ON_BN_CLICKED(IDC_CHECK_EVENT_RECORD, OnCheckEventRecord)
	ON_BN_CLICKED(IDC_BUTTON_RECORD, OnButtonRecord)
	ON_BN_CLICKED(IDC_CHECK_EVENT_MD, OnCheckEventMd)
	ON_BN_CLICKED(IDC_CHECK_EVENT_DI1RISE, OnCheckEventDi1rise)
	ON_BN_CLICKED(IDC_CHECK_EVENT_DI1FALL, OnCheckEventDi1fall)
	ON_BN_CLICKED(IDC_CHECK_EVENT_DI1HIGH, OnCheckEventDi1high)
	ON_BN_CLICKED(IDC_CHECK_EVENT_DI1LOW, OnCheckEventDi1low)
	ON_BN_CLICKED(IDC_CHECK_EVENT_DI2RISE, OnCheckEventDi2rise)
	ON_BN_CLICKED(IDC_CHECK_EVENT_DI3FALL, OnCheckEventDi3fall)
	ON_BN_CLICKED(IDC_CHECK_EVENT_DI4HIGH, OnCheckEventDi4high)
	ON_BN_CLICKED(IDC_BUTTON_HTTP_POST, OnButtonHttpPost)
	ON_BN_CLICKED(IDC_BUTTON_HTTP_GET, OnButtonHttpGet)
	ON_BN_CLICKED(IDC_CHK_AVI_SHOW, OnChkAviShow)
	ON_BN_CLICKED(IDC_BUT_AVI_START, OnButAviStart)
	ON_BN_CLICKED(IDC_CHK_AVI_AUTOSET, OnChkAviAutoset)
	ON_BN_CLICKED(IDC_CHK_AVI_AUTOSIZE, OnChkAviAutosize)
	ON_BN_CLICKED(IDC_BUT_AVI_UPDSET, OnButAviUpdset)
	ON_BN_CLICKED(IDC_BUT_AVI_VCOMP, OnButAviVcomp)
	ON_BN_CLICKED(IDC_BUT_AVI_ACOMP, OnButAviAcomp)
	ON_BN_CLICKED(IDC_CHK_TEST_INPUT, OnChkTestInput)
	ON_BN_CLICKED(IDC_BUT_SET_REFRESH, OnButSetRefresh)
	ON_BN_CLICKED(IDC_BUT_SET_READ, OnButSetRead)
	ON_BN_CLICKED(IDC_BUT_SET_SET, OnButSetSet)
	ON_BN_CLICKED(IDC_BUT_SET_UPD, OnButSetUpd)
	ON_BN_CLICKED(IDC_BUT_DATETIME_SET, OnButDatetimeSet)
	ON_BN_CLICKED(IDC_CHK_AUDIO, OnChkAudio)
	ON_BN_CLICKED(IDC_BUT_SAVE_PRESET, OnButSavePreset)
	ON_EN_CHANGE(IDC_EDIT_JPG_INTERVAL, OnChangeEditJpgInterval)
	ON_BN_CLICKED(IDC_CHECK_VOLCTRL, OnCheckVolctrl)
	ON_BN_CLICKED(IDC_CHECK_MICCTRL, OnCheckMicctrl)
	ON_BN_CLICKED(IDC_CHECK_TALK_BTN, OnCheckTalkBtn)
	ON_BN_CLICKED(IDC_CHECK_DECODEAV, OnCheckDecodeav)
	ON_BN_CLICKED(IDC_CHECK_MOTION_FRM, OnCheckMotionFrm)
	ON_EN_CHANGE(IDC_EDIT_DISPLAY_PERIOD, OnChangeEditDisplayPeriod)
	ON_BN_CLICKED(IDC_BUT_CUST1, OnButCust1)
	ON_BN_CLICKED(IDC_BUT_CUST2, OnButCust2)
	ON_BN_CLICKED(IDC_BUT_CUST3, OnButCust3)
	ON_BN_CLICKED(IDC_BUT_CUST4, OnButCust4)
	ON_BN_CLICKED(IDC_BUT_IRISAUTO, OnButIrisauto)
	ON_BN_CLICKED(IDC_BUT_IRISCLOSE, OnButIrisclose)
	ON_BN_CLICKED(IDC_BUT_IRISOPEN, OnButIrisopen)
	ON_BN_CLICKED(IDC_CHECK_FORCE_NONYUV, OnCheckForceNonyuv)
	ON_BN_CLICKED(IDC_CHECK_AUTO_SERVERMODEL, OnCheckAutoServermodel)
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_BUT_SNAP_MEM, OnButSnapMem)
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO_STREAM, OnCbnSelchangeComboStream)
	ON_BN_CLICKED(IDC_CHECK_TWOWAYAUDIO, OnBnClickedCheckTwowayaudio)
	ON_BN_CLICKED(IDC_BUTTON_FULLSCREEN, OnBnClickedButtonFullscreen)
	END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVctestDlg message handlers

BOOL CVctestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// we must move panel4Ch to the same position of panel1Ch
	// and panelConn2K to the same position of panelConnNon2K
	Move4ChDiDoCtrlPos();

	// connect vs3101 move to the same position of audio
	MoveWindowToCtrl(IDC_CHECK_CONNECT_3101, IDC_CHECK_AUDIO);

	// init the streaming option to streaming
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_STREAM_OPT);
	pBox->SetCurSel(0);

	// init the snapshot fmt for 2K to Jpeg
	pBox = (CComboBox *) GetDlgItem(IDC_COMBO_SNAP_FMT);
	pBox->SetCurSel(0);

	// init the video decoded fmt to Jpeg
	pBox = (CComboBox *) GetDlgItem(IDC_COMBO_VIDEODEC_FMT);
	pBox->SetCurSel(0);

	// init the user time fmt to 24hr
	pBox = (CComboBox *) GetDlgItem(IDC_COMBO_USR_TIMEFMT);
	pBox->SetCurSel(0);

	// init the UART port of 4Ch to port 1
	pBox = (CComboBox *) GetDlgItem(IDC_COMBO_UART_PORT);
	pBox->SetCurSel(0);

	// init quality for 2K to Good
	pBox = (CComboBox *) GetDlgItem(IDC_COMBO_QUALITY);
	pBox->SetCurSel(2);

	// init vsize for 2K to normal
	pBox = (CComboBox *) GetDlgItem(IDC_COMBO_VSIZE);
	pBox->SetCurSel(1);

	// init channel for 4Ch to 1
	pBox = (CComboBox *) GetDlgItem(IDC_COMBO_CHANNEL);
	pBox->SetCurSel(0);

	// initialize the control to 6K servers mode. we must also initialize the panel layout here
	pBox = (CComboBox *) GetDlgItem(IDC_COMBO_SERVER_TYPE);
	pBox->SetCurSel(2);

	// sam 2007/05/02 initialize the ViewStream to none
	pBox = (CComboBox *) GetDlgItem(IDC_COMBO_STREAM);
	pBox->SetCurSel(0);

	// init mist check box value
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_AUTO_RECONNECT);
	pBut->SetCheck(1);
	
	pBut = (CButton *) GetDlgItem(IDC_CHECK_AUDIO);
	pBut->SetCheck(1);

	pBut = (CButton *) GetDlgItem(IDC_CHECK_DISPLAY);
	pBut->SetCheck(1);

	pBut = (CButton *) GetDlgItem(IDC_CHECK_VOLCTRL);
	pBut->SetCheck(1);

	pBut = (CButton *) GetDlgItem(IDC_CHECK_MICCTRL);
	pBut->SetCheck(1);

	pBut = (CButton *) GetDlgItem(IDC_CHECK_TALK_BTN);
	pBut->SetCheck(1);

	pBut = (CButton *) GetDlgItem(IDC_CHECK_ZOOM_EDIT);
	pBut->SetCheck(1);

	pBut = (CButton *) GetDlgItem(IDC_CHECK_STRETCH);
	pBut->SetCheck(1);

	pBut = (CButton *) GetDlgItem(IDC_CHECK_EVENT_MD);
	pBut->SetCheck(1);

	pBut = (CButton *) GetDlgItem(IDC_CHECK_EVENT_DI1RISE);
	pBut->SetCheck(1);

	pBut = (CButton *) GetDlgItem(IDC_CHECK_EVENT_DI1FALL);
	pBut->SetCheck(1);

	pBut = (CButton *) GetDlgItem(IDC_CHECK_EVENT_DI1HIGH);
	pBut->SetCheck(1);

	pBut = (CButton *) GetDlgItem(IDC_CHECK_EVENT_DI1LOW);
	pBut->SetCheck(1);

	pBut = (CButton *) GetDlgItem(IDC_CHK_AVI_AUTOSET);
	pBut->SetCheck(1);

	pBut = (CButton *) GetDlgItem(IDC_CHK_AVI_AUTOSIZE);
	pBut->SetCheck(1);

	pBut = (CButton *) GetDlgItem(IDC_CHECK_DECODEAV);
	pBut->SetCheck(1);

	pBut = (CButton *) GetDlgItem(IDC_CHECK_MOTION_FRM);
	pBut->SetCheck(1);

	pBut = (CButton *) GetDlgItem(IDC_CHECK_AUTO_SERVERMODEL);
	pBut->SetCheck(1);

	m_vitCtrl1.SetAutoServerModelType(TRUE);			


	// init misc edit box value
	GetDlgItem(IDC_EDIT_JPEGQ)->SetWindowText("20");
	GetDlgItem(IDC_EDIT_SERV_IP)->SetWindowText("192.168.1.240");
	GetDlgItem(IDC_EDIT_PORT)->SetWindowText("80");
	GetDlgItem(IDC_EDIT_ROOT_ID)->SetWindowText("root");
	GetDlgItem(IDC_EDIT_ROOT_PWD)->SetWindowText("123");
	GetDlgItem(IDC_EDIT_JPG_INTERVAL)->SetWindowText("1");
	GetDlgItem(IDC_EDIT_AVI_VFR)->SetWindowText("15");
	GetDlgItem(IDC_EDIT_AVI_W)->SetWindowText("352");
	GetDlgItem(IDC_EDIT_AVI_H)->SetWindowText("240");
	GetDlgItem(IDC_EDIT_SET_INDEX)->SetWindowText("0");
	GetDlgItem(IDC_EDIT_DISPLAY_PERIOD)->SetWindowText("1");

	OnSelchangeComboServerType();
	SetAVIButtonStatus();
	UpdateServerSetStatus(false);

	SetEventType();

	ResetControls(FALSE);

	SetTimer(1, 1000, NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVctestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVctestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVctestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVctestDlg::HandleAudioRelatedCtrl(bool bShow)
{
	GetDlgItem(IDC_CHK_AUDIO)->ShowWindow(bShow?SW_SHOW:SW_HIDE);
	GetDlgItem(IDC_EDIT_ADEC_SIZE)->ShowWindow(bShow?SW_SHOW:SW_HIDE);
	GetDlgItem(IDC_EDIT_ADEC_TIME)->ShowWindow(bShow?SW_SHOW:SW_HIDE);
	GetDlgItem(IDC_STATIC_ABR)->ShowWindow(bShow?SW_SHOW:SW_HIDE);
	GetDlgItem(IDC_EDIT_ABR)->ShowWindow(bShow?SW_SHOW:SW_HIDE);
	GetDlgItem(IDC_BUT_AVI_ACOMP)->ShowWindow(bShow?SW_SHOW:SW_HIDE);
}

void CVctestDlg::Handle1Or4Channel(bool b1Ch)
{
	// set all 4 channel and 1 channel di/do to show or hide
	int nCnt;

	// 4 channel part
	for (nCnt = IDC_STATIC_4CH_DO1; nCnt <= IDC_BUT_4CH_DI4; nCnt++)
	{
		GetDlgItem(nCnt)->ShowWindow(b1Ch?SW_HIDE:SW_SHOW);
	}

	// 1 channel part
	for (nCnt = IDC_STATIC_DO; nCnt <= IDC_EDIT_DIIMG; nCnt++)
	{
		GetDlgItem(nCnt)->ShowWindow(b1Ch?SW_SHOW:SW_HIDE);
	}

	GetDlgItem(IDC_STATIC_CHANNEL)->ShowWindow(b1Ch?SW_HIDE:SW_SHOW);
	GetDlgItem(IDC_COMBO_CHANNEL)->ShowWindow(b1Ch?SW_HIDE:SW_SHOW);

	if (b1Ch)
	{
		CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_CHANNEL);
		pBox->SetCurSel(0);
	}
	GetDlgItem(IDC_STATIC_UART_PORT)->ShowWindow(b1Ch?SW_HIDE:SW_SHOW);
	GetDlgItem(IDC_COMBO_UART_PORT)->ShowWindow(b1Ch?SW_HIDE:SW_SHOW);

	GetDlgItem(IDC_CHECK_EVENT_DI2RISE)->ShowWindow(b1Ch?SW_HIDE:SW_SHOW);
	GetDlgItem(IDC_CHECK_EVENT_DI3FALL)->ShowWindow(b1Ch?SW_HIDE:SW_SHOW);
	GetDlgItem(IDC_CHECK_EVENT_DI4HIGH)->ShowWindow(b1Ch?SW_HIDE:SW_SHOW);
}

void CVctestDlg::SetupInitProtocol(int nIndex)
{
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_PROTOCOL);

	if (nIndex == 1)
	{
		// 3K, TCP, UDP, Http
		pBox->ResetContent();
		pBox->AddString("UDP");
		pBox->AddString("TCP");
		pBox->AddString("HTTP");
		// init to TCP
		pBox->SetCurSel(1);
	}
	else if (nIndex == 2)
	{
		// 4/5/6 K, UDP, Http
		pBox->ResetContent();
		pBox->AddString("UDP");
		pBox->AddString("HTTP");
		// init to Http
		pBox->SetCurSel(1);
	}
	// sam 2007/05/02 add 7KDual model type (nIndex = 5)
	else if (nIndex == 3 || nIndex == 5)
	{
		// 7K TCP, UDP, HTTP, MultiCast
		pBox->ResetContent();		
		pBox->AddString("UDP");
		pBox->AddString("TCP");		
		pBox->AddString("HTTP");
		pBox->AddString("MultiCast");
		// init to UDP
		pBox->SetCurSel(0);
	}
}

void CVctestDlg::SetupControlProtocol(int nIndex)
{
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_PROTOCOL);

	if (nIndex == 0 || nIndex == 4)
	{
		// 2K
		m_vitCtrl1.SetConnectionProtocol(3);
	}
	else if (nIndex == 1)
	{
		// 3K
		m_vitCtrl1.SetConnectionProtocol(pBox->GetCurSel() + 1);
	}
	else if (nIndex == 2)
	{
		// 4/5/6 K
		if (pBox->GetCurSel() == 0)
			m_vitCtrl1.SetConnectionProtocol(1);
		else
			m_vitCtrl1.SetConnectionProtocol(3);
	}
	else if (nIndex == 3 || nIndex == 5) // sam 2007/05/02 add 7KDual
	{
		m_vitCtrl1.SetConnectionProtocol(pBox->GetCurSel() + 1);
	}
}

void CVctestDlg::HandleConnOptCtrl(bool b2K)
{
	// if 2K, hide the protocol, MDEdit, Audo part
	// else hide the quality, size part
	GetDlgItem(IDC_STATIC_PROTOCOL)->ShowWindow(b2K?SW_HIDE:SW_SHOW);
	GetDlgItem(IDC_COMBO_PROTOCOL)->ShowWindow(b2K?SW_HIDE:SW_SHOW);
	GetDlgItem(IDC_CHECK_MOEDIT)->ShowWindow(b2K?SW_HIDE:SW_SHOW);
	GetDlgItem(IDC_CHECK_AUDIO)->ShowWindow(b2K?SW_HIDE:SW_SHOW);
	GetDlgItem(IDC_STATIC_QUALITY)->ShowWindow(b2K?SW_SHOW:SW_HIDE);
	GetDlgItem(IDC_COMBO_QUALITY)->ShowWindow(b2K?SW_SHOW:SW_HIDE);
	GetDlgItem(IDC_STATIC_VSIZE)->ShowWindow(b2K?SW_SHOW:SW_HIDE);
	GetDlgItem(IDC_COMBO_VSIZE)->ShowWindow(b2K?SW_SHOW:SW_HIDE);

	// always hide this window initially
	GetDlgItem(IDC_CHECK_CONNECT_3101)->ShowWindow(SW_HIDE);
}

void CVctestDlg::ChangeUIItems(int nSel, bool bIsChangeProtocol)
{
	if (nSel == 0)
	{
		// 2K one channel
		HandleAudioRelatedCtrl(false);
		Handle1Or4Channel(true);

		HandleConnOptCtrl(true);
		HandleCtrlBtn(false, false);
		GetDlgItem(IDC_BUT_IRISAUTO)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BUT_IRISOPEN)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BUT_IRISCLOSE)->ShowWindow(SW_HIDE);
	}
	else if (nSel == 1)
	{
		// 3K
		HandleAudioRelatedCtrl(true);
		Handle1Or4Channel(true);

		HandleConnOptCtrl(false);
		// always hide this window initially
		GetDlgItem(IDC_CHECK_CONNECT_3101)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_CHECK_AUDIO)->ShowWindow(SW_HIDE);
		HandleCtrlBtn(true, false);
		GetDlgItem(IDC_BUT_IRISAUTO)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BUT_IRISOPEN)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BUT_IRISCLOSE)->ShowWindow(SW_HIDE);
	}
	else if (nSel == 2)
	{
		// 4/5/6 k server
		HandleAudioRelatedCtrl(true);
		Handle1Or4Channel(true);

		HandleConnOptCtrl(false);
		HandleCtrlBtn(true, true);
		GetDlgItem(IDC_BUT_IRISAUTO)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BUT_IRISOPEN)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BUT_IRISCLOSE)->ShowWindow(SW_SHOW);
	}
	else if (nSel == 3 || nSel == 5)
	{
		// 7 k server
		HandleAudioRelatedCtrl(true);
		Handle1Or4Channel(true);

		HandleConnOptCtrl(false);
		HandleCtrlBtn(true, false);
		GetDlgItem(IDC_BUT_IRISAUTO)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BUT_IRISOPEN)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BUT_IRISCLOSE)->ShowWindow(SW_HIDE);
	}
	else if (nSel == 4)
	{
		// 2K 4 channels
		HandleAudioRelatedCtrl(false);
		Handle1Or4Channel(false);

		HandleConnOptCtrl(true);
		HandleCtrlBtn(false, false);
		GetDlgItem(IDC_BUT_IRISAUTO)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BUT_IRISOPEN)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BUT_IRISCLOSE)->ShowWindow(SW_HIDE);
	}

	SetupInitProtocol(nSel);
	if (bIsChangeProtocol)
		SetupControlProtocol(nSel);
}

void CVctestDlg::HandleCtrlBtn(bool bVol, bool bTalk)
{
	GetDlgItem(IDC_CHECK_VOLCTRL)->ShowWindow(bVol?SW_SHOW:SW_HIDE);
	GetDlgItem(IDC_CHECK_MICCTRL)->ShowWindow(bTalk?SW_SHOW:SW_HIDE);
	GetDlgItem(IDC_CHECK_TALK_BTN)->ShowWindow(bTalk?SW_SHOW:SW_HIDE);
}

void CVctestDlg::OnSelchangeComboServerType() 
{
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_SERVER_TYPE);

	int nSel = pBox->GetCurSel();

	ChangeUIItems(nSel, true);

	m_vitCtrl1.SetServerModelType(nSel);
	m_vitCtrl2.SetServerModelType(nSel);
}

void CVctestDlg::Move4ChDiDoCtrlPos()
{
	// use the x difference of IDC_STATIC_4CH_DO1 and IDC_STATIC_DO to move each control
	// between IDC_STATIC_4CH_DO1 and IDC_BUT_4CH_DI4
	CRect rectOther, rect4K;
	int nXDiff;

	GetDlgItem(IDC_STATIC_4CH_DO1)->GetWindowRect(&rect4K);
	GetDlgItem(IDC_STATIC_DO)->GetWindowRect(&rectOther);
	nXDiff = rect4K.left - rectOther.left;

	CRect rect;

	for (int nCnt = IDC_STATIC_4CH_DO1; nCnt <= IDC_BUT_4CH_DI4; nCnt++)
	{
		GetDlgItem(nCnt)->GetWindowRect(&rect);
		rect.left -= nXDiff;
		rect.right -= nXDiff;
		ScreenToClient(&rect);
		GetDlgItem(nCnt)->MoveWindow(rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top);
	}
}

void CVctestDlg::MoveWindowToCtrl(int nTarget, int nSrc)
{
	CRect rectTarget, rectSrc;
	int nXDiff;

	GetDlgItem(nTarget)->GetWindowRect(&rectTarget);
	GetDlgItem(nSrc)->GetWindowRect(&rectSrc);
	nXDiff = rectTarget.left - rectSrc.left;

	rectTarget.left -= nXDiff;
	rectTarget.right -= nXDiff;

	ScreenToClient(&rectTarget);
	GetDlgItem(nTarget)->MoveWindow(rectTarget.left, rectTarget.top, 
		rectTarget.right - rectTarget.left, rectTarget.bottom - rectTarget.top);
}

void CVctestDlg::SetAVIButtonStatus()
{
	bool bAutoSet;
	bool bSizeByStream;
	CButton *pBut;

	pBut = (CButton *) GetDlgItem(IDC_CHK_AVI_AUTOSET);
	bAutoSet = pBut->GetCheck()?true:false;
	pBut = (CButton *) GetDlgItem(IDC_CHK_AVI_AUTOSIZE);
	bSizeByStream = pBut->GetCheck()?true:false;

	GetDlgItem(IDC_STATIC_AVI_VFR)->EnableWindow(!bAutoSet);
	GetDlgItem(IDC_EDIT_AVI_VFR)->EnableWindow(!bAutoSet);
	GetDlgItem(IDC_CHK_AVI_AUTOSIZE)->EnableWindow(!bAutoSet);
	GetDlgItem(IDC_BUT_AVI_UPDSET)->EnableWindow(!bAutoSet);
	GetDlgItem(IDC_BUT_AVI_VCOMP)->EnableWindow(!bAutoSet);
	GetDlgItem(IDC_BUT_AVI_ACOMP)->EnableWindow(!bAutoSet);

	GetDlgItem(IDC_STATIC_AVI_W)->EnableWindow(!bAutoSet && !bSizeByStream);
	GetDlgItem(IDC_EDIT_AVI_W)->EnableWindow(!bAutoSet && !bSizeByStream);
	GetDlgItem(IDC_STATIC_AVI_H)->EnableWindow(!bAutoSet && !bSizeByStream);
	GetDlgItem(IDC_EDIT_AVI_H)->EnableWindow(!bAutoSet && !bSizeByStream);
}

void CVctestDlg::UpdateServerSetStatus(bool bEnable)
{
	for (int nCnt = IDC_BUT_SET_UPD; nCnt <= IDC_BUT_DATETIME_SET; nCnt++)
	{
		GetDlgItem(nCnt)->EnableWindow(bEnable);
	}
}

void CVctestDlg::SetEventType()
{
	int nVal = 0;
	CButton *pBut;

	pBut = (CButton *) GetDlgItem(IDC_CHECK_EVENT_MD);
	if (pBut->GetCheck())
		nVal |= 7;
	pBut = (CButton *) GetDlgItem(IDC_CHECK_EVENT_DI1RISE);
	if (pBut->GetCheck())
		nVal |= (1 << 21);
	pBut = (CButton *) GetDlgItem(IDC_CHECK_EVENT_DI1FALL);
	if (pBut->GetCheck())
		nVal |= (1 << 25);
	pBut = (CButton *) GetDlgItem(IDC_CHECK_EVENT_DI1HIGH);
	if (pBut->GetCheck())
		nVal |= (1 << 16);
	pBut = (CButton *) GetDlgItem(IDC_CHECK_EVENT_DI1LOW);
	if (pBut->GetCheck())
		nVal |= (1 << 8);

	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_PROTOCOL);

	if (pBox->GetCurSel() == 4)
	{

		pBut = (CButton *) GetDlgItem(IDC_CHECK_EVENT_DI2RISE);
		if (pBut->GetCheck())
			nVal |= (1 << 22);
		pBut = (CButton *) GetDlgItem(IDC_CHECK_EVENT_DI3FALL);
		if (pBut->GetCheck())
			nVal |= (1 << 27);
		pBut = (CButton *) GetDlgItem(IDC_CHECK_EVENT_DI4HIGH);
		if (pBut->GetCheck())
			nVal |= (1 << 19);
	}

	m_vitCtrl1.SetEventTypes(nVal);
}

void CVctestDlg::UpdatePresetLocation()
{
    // reset the content of the combo box
	CComboBox *pCom = (CComboBox *) GetDlgItem(IDC_COMBO_PRESET);
	pCom->ResetContent();

	VARIANT vData;
	VariantInit(&vData);
    long lRet = m_vitCtrl1.GetPtzPresetPosition(&vData);
	if (lRet == 3001 || lRet != 0)
		return;

	if (vData.vt != (VT_ARRAY | VT_VARIANT)) 
	{
		MessageBox("Return data type incorrect!", "Error", MB_OK | MB_ICONERROR);
		VariantClear(&vData);
		return;
	}

	long Dims = SafeArrayGetDim(vData.parray);
	if (Dims != 1)
	{
		MessageBox("Return array dimension incorrect!", "Error", MB_OK | MB_ICONERROR);
		VariantClear(&vData);
		return;
	}
	long UpperBounds;
	long LowerBounds;
	SafeArrayGetLBound(vData.parray, 1, &LowerBounds);
	SafeArrayGetUBound(vData.parray, 1, &UpperBounds);

	int nSize = UpperBounds - LowerBounds;
	if (nSize < 0)
	{
		MessageBox("Return array size is less than 0", "Error", MB_OK | MB_ICONERROR);
		VariantClear(&vData);
		return;
	}

	CComVariant varCom;
	USES_CONVERSION;
	for (int nCnt = 0; nCnt <= nSize; nCnt++)
	{
		HRESULT hresult = SafeArrayGetElement(vData.parray, (long *) &nCnt, &varCom);
		if (FAILED(hresult))
			break;
		
		pCom->AddString(W2A(varCom.bstrVal));
	}

	if (pCom->GetCount() > 0)
		pCom->SetCurSel(0);

}

void CVctestDlg::ResetControls(BOOL bEnable)
{
	int nCnt;

	// camera control
	for (nCnt = IDC_BUT_UP; nCnt <= IDC_BUT_PTSTOP; nCnt++)
	{
		GetDlgItem(nCnt)->EnableWindow(bEnable);
	}

	GetDlgItem(IDC_STATIC_CAMCTRL)->EnableWindow(bEnable);

	// snapshot
	for (nCnt = IDC_STATIC_FNAME; nCnt <= IDC_COMBO_SNAP_FMT; nCnt++)
	{
		GetDlgItem(nCnt)->EnableWindow(bEnable);
	}
	
	// snapshot mem
	GetDlgItem(IDC_BUT_SNAP_MEM)->EnableWindow(bEnable);

	// uart
	for (nCnt = IDC_STATIC_CMD; nCnt <= IDC_COMBO_UART_PORT; nCnt++)
	{
		GetDlgItem(nCnt)->EnableWindow(bEnable);
	}

	// AVI start
	GetDlgItem(IDC_BUT_AVI_START)->EnableWindow(bEnable);

	// preset location
	for (nCnt = IDC_STATIC_PRESET_NAME; nCnt <= IDC_EDIT_PRESET; nCnt++)
	{
		GetDlgItem(nCnt)->EnableWindow(bEnable);
	}

	// DI/DO
	for (nCnt = IDC_STATIC_DO; nCnt <= IDC_BUT_4CH_DI4; nCnt++)
	{
		GetDlgItem(nCnt)->EnableWindow(bEnable);
	}

	// Input packet
	GetDlgItem(IDC_CHK_TEST_INPUT)->EnableWindow(bEnable);

	GetDlgItem(IDC_BUT_CUST1)->EnableWindow(bEnable);
	GetDlgItem(IDC_BUT_CUST2)->EnableWindow(bEnable);
	GetDlgItem(IDC_BUT_CUST3)->EnableWindow(bEnable);
	GetDlgItem(IDC_BUT_CUST4)->EnableWindow(bEnable);
	GetDlgItem(IDC_BUT_IRISAUTO)->EnableWindow(bEnable);
	GetDlgItem(IDC_BUT_IRISOPEN)->EnableWindow(bEnable);
	GetDlgItem(IDC_BUT_IRISCLOSE)->EnableWindow(bEnable);

	if (bEnable)
	{
		UpdatePresetLocation();
	}
}

void CVctestDlg::OnTimer(UINT nIDEvent) 
{
	char szTemp[256];

	sprintf(szTemp, "%d", m_vitCtrl1.GetFrameRate());
	GetDlgItem(IDC_EDIT_FR)->SetWindowText(szTemp);

	sprintf(szTemp, "%d", m_vitCtrl1.GetVideoBitRate());
	GetDlgItem(IDC_EDIT_VBR)->SetWindowText(szTemp);

	sprintf(szTemp, "%d", m_vitCtrl1.GetAudioBitRate());
	GetDlgItem(IDC_EDIT_ABR)->SetWindowText(szTemp);

	GetDlgItem(IDC_EDIT_TEXT_ONVIDEO)->SetWindowText(m_vitCtrl1.GetTextOnVideo());

	VARIANT vData;
	VariantInit(&vData);
    long lRet = m_vitCtrl1.GetConnectionStatus(&vData);
	if (lRet != 0)
		return;

	if (vData.vt != (VT_ARRAY | VT_VARIANT)) 
	{
		MessageBox("Return data type incorrect!", "Error", MB_OK | MB_ICONERROR);
		VariantClear(&vData);
		return;
	}

	long Dims = SafeArrayGetDim(vData.parray);
	if (Dims != 1)
	{
		MessageBox("Return array dimension incorrect!", "Error", MB_OK | MB_ICONERROR);
		VariantClear(&vData);
		return;
	}

	long UpperBounds;
	long LowerBounds;
	SafeArrayGetLBound(vData.parray, 1, &LowerBounds);
	SafeArrayGetUBound(vData.parray, 1, &UpperBounds);

	int nSize = UpperBounds - LowerBounds + 1;
	if (nSize != 3)
	{
		MessageBox("Return array size is incorrect", "Error", MB_OK | MB_ICONERROR);
		VariantClear(&vData);
		return;
	}

	CComVariant varCom;
	int nCnt = 0;
	HRESULT hresult = SafeArrayGetElement(vData.parray, (long *) &nCnt, &varCom);
	if (FAILED(hresult))
	{
		VariantClear(&vData);
		return;
	}
	sprintf(szTemp, "%d", varCom.lVal);
	GetDlgItem(IDC_EDIT_RECONN_TIMES)->SetWindowText(szTemp);
	
	nCnt = 1;
	hresult = SafeArrayGetElement(vData.parray, (long *) &nCnt, &varCom);
	if (FAILED(hresult))
	{
		VariantClear(&vData);
		return;
	}
	sprintf(szTemp, "%d", varCom.lVal);
	GetDlgItem(IDC_EDIT_CONN_SECS)->SetWindowText(szTemp);

	nCnt = 2;
	hresult = SafeArrayGetElement(vData.parray, (long *) &nCnt, &varCom);
	if (FAILED(hresult))
	{
		VariantClear(&vData);
		return;
	}
	sprintf(szTemp, "%d", varCom.lVal);
	GetDlgItem(IDC_EDIT_TOT_SECS)->SetWindowText(szTemp);

	VariantClear(&vData);
}

void CVctestDlg::DoDOSet(int nID, int nPort)
{
	// get the value here
	CString strValue;

	GetDlgItem(nID)->GetWindowText(strValue);
	if (strValue.GetLength() == 0)
	{
		MessageBox("Should give the DO value");
		return;
	}

	int nVal = atoi(strValue);
	// note: it would be better to do some value check here
	m_vitCtrl1.SendDigitalOut(nPort, nVal);		
}

void CVctestDlg::OnButDoSet() 
{
	DoDOSet(IDC_EDIT_DO, 1);
}

void CVctestDlg::OnBut4chDoset1() 
{
	DoDOSet(IDC_EDIT_4CH_DO1, 1);
}

void CVctestDlg::OnBut4chDoset2() 
{
	DoDOSet(IDC_EDIT_4CH_DO2, 2);
}

CString CVctestDlg::DoGetDi(int nDiPort)
{
	VARIANT vData;
	VariantInit(&vData);
	CString strTemp;

	m_vitCtrl1.GetDigitalIn(nDiPort, &vData);

	int nData = vData.lVal;

	if (nData == 0)
		strTemp = "L";
	else
		strTemp = "H";

	return strTemp;

}

void CVctestDlg::OnButDiGet() 
{
	GetDlgItem(IDC_EDIT_DI)->SetWindowText(DoGetDi(1));
}

void CVctestDlg::OnBut4chDi1() 
{
	GetDlgItem(IDC_EDIT_4CH_DI1)->SetWindowText(DoGetDi(1));
}

void CVctestDlg::OnBut4chDi2() 
{
	GetDlgItem(IDC_EDIT_4CH_DI2)->SetWindowText(DoGetDi(2));
}

void CVctestDlg::OnBut4chDi3() 
{
	GetDlgItem(IDC_EDIT_4CH_DI3)->SetWindowText(DoGetDi(3));
}

void CVctestDlg::OnBut4chDi4() 
{
	GetDlgItem(IDC_EDIT_4CH_DI4)->SetWindowText(DoGetDi(4));
}

void CVctestDlg::OnChkVideo() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHK_VIDEO);

	m_vitCtrl1.SetNotifyVideoData(pBut->GetCheck());
}

void CVctestDlg::OnChkAudio() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHK_AUDIO);

	m_vitCtrl1.SetNotifyNewAudio(pBut->GetCheck());	
}

void CVctestDlg::OnSelchangeComboVideodecFmt() 
{
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_VIDEODEC_FMT);

	m_vitCtrl1.SetNotifyImageFormat(pBox->GetCurSel() + 1);	
}

void CVctestDlg::OnChangeEditJpegq() 
{
	CString strVal;

	GetDlgItem(IDC_EDIT_JPEGQ)->GetWindowText(strVal);

	if (strVal.GetLength() > 0)
		m_vitCtrl1.SetJpegQuality(atoi(strVal));
	
}

void CVctestDlg::OnButUp() 
{
	m_vitCtrl1.SendCameraCommand("up", 3000);
}

void CVctestDlg::OnButLeft() 
{
	m_vitCtrl1.SendCameraCommand("left", 3000);
}

void CVctestDlg::OnButHome() 
{
	m_vitCtrl1.SendCameraCommand("home", 3000);
}

void CVctestDlg::OnButRight() 
{
	m_vitCtrl1.SendCameraCommand("right", 3000);
}

void CVctestDlg::OnButDown() 
{
	m_vitCtrl1.SendCameraCommand("down", 3000);
}

void CVctestDlg::OnButTele() 
{
	m_vitCtrl1.SendCameraCommand("tele", 3000);
}

void CVctestDlg::OnButWide() 
{
	m_vitCtrl1.SendCameraCommand("wide", 3000);
}

void CVctestDlg::OnButFar() 
{
	m_vitCtrl1.SendCameraCommand("far", 3000);
}

void CVctestDlg::OnButNear() 
{
	m_vitCtrl1.SendCameraCommand("near", 3000);
}

void CVctestDlg::OnButAuto() 
{
	m_vitCtrl1.SendCameraCommand("auto", 3000);
}

void CVctestDlg::OnButPan() 
{
	m_vitCtrl1.SendCameraCommand("pan", 3000);
}

void CVctestDlg::OnButPatrol() 
{
	m_vitCtrl1.SendCameraCommand("patrol", 3000);
}

void CVctestDlg::OnButPtstop() 
{
	m_vitCtrl1.SendCameraCommand("stop", 3000);
}

void CVctestDlg::OnButtonConn() 
{
	int ii = m_vitCtrl1.GetControlStatus();
    if (m_vitCtrl1.GetControlStatus() != 0 &&
		m_vitCtrl1.GetControlStatus() != 3 && 
		m_vitCtrl1.GetControlStatus() != 5) // sam add connection broken
	{
        m_vitCtrl1.Disconnect();
		return;
	}

	CString strServIP, strRootPwd, strUserName, strTemp;

	GetDlgItem(IDC_EDIT_SERV_IP)->GetWindowText(strServIP);
	GetDlgItem(IDC_EDIT_PORT)->GetWindowText(strTemp);
	GetDlgItem(IDC_EDIT_ROOT_ID)->GetWindowText(strUserName);
	GetDlgItem(IDC_EDIT_ROOT_PWD)->GetWindowText(strRootPwd);

	m_vitCtrl1.SetPassword(strRootPwd);
	m_vitCtrl1.SetUserName(strUserName);
	m_vitCtrl1.SetRemoteIPAddr(strServIP);
	long lPort = atoi(strTemp);
	if (lPort <= 0 || lPort > 65535)
		lPort = 80;
	m_vitCtrl1.SetHttpPort(lPort);
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_SERVER_TYPE);

	if (pBox->GetCurSel() == 1)
	{
		CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_CONNECT_3101);
		if (pBut->GetCheck())
		{
			m_vitCtrl1.SetUrl("/cgi-bin/video.263");
			m_vitCtrl1.SetConnectionProtocol(3);
		}
	}


	m_vitCtrl1.Connect();

	GetDlgItem(IDC_EDIT_SERV_IP)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_PORT)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_ROOT_ID)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_ROOT_PWD)->EnableWindow(FALSE);

	GetDlgItem(IDC_BUTTON_CONN)->SetWindowText("Stop");

	ResetControls(FALSE);
	m_dwDecodedAudioSize = 0;
	m_dwDecodedVideoSize = 0;	
}

void CVctestDlg::OnCheckAutoReconnect() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_AUTO_RECONNECT);
	m_vitCtrl1.SetAutoReconnect(pBut->GetCheck());
}

void CVctestDlg::OnSelchangeComboStreamOpt() 
{
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_STREAM_OPT);
	m_vitCtrl1.SetStreamingOption(pBox->GetCurSel() + 1);

	CString strVal;

	GetDlgItem(IDC_EDIT_JPG_INTERVAL)->GetWindowText(strVal);

	if (strVal.GetLength() != 0)
	{
		m_vitCtrl1.SetJpegSecsPerFrame(atoi(strVal));
	}
	
}

void CVctestDlg::OnSelchangeComboProtocol() 
{
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_SERVER_TYPE);
	SetupControlProtocol(pBox->GetCurSel());
}

void CVctestDlg::OnCheckMoedit() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_MOEDIT);
	m_vitCtrl1.SetMDEditMode(pBut->GetCheck());
}

void CVctestDlg::OnCheckAudio() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_AUDIO);

	if (pBut->GetCheck())
		m_vitCtrl1.SetMediaType(3);
	else
		m_vitCtrl1.SetMediaType(1);
	
}

void CVctestDlg::OnSelchangeComboQuality() 
{
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_QUALITY);
	m_vitCtrl1.SetVideoQuality2K(pBox->GetCurSel() + 1);

	// reconnect the connection with new video channel
	if (m_vitCtrl1.GetControlStatus() != 0 && 
		m_vitCtrl1.GetControlStatus() != 3)
	{
		m_vitCtrl1.Disconnect();
		m_vitCtrl1.Connect();
	}
}

void CVctestDlg::OnSelchangeComboVsize() 
{
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_VSIZE);
	m_vitCtrl1.SetVideoSize2K(pBox->GetCurSel() + 1);

	// reconnect the connection with new video channel
	if (m_vitCtrl1.GetControlStatus() != 0 && 
		m_vitCtrl1.GetControlStatus() != 3)
	{
		m_vitCtrl1.Disconnect();
		m_vitCtrl1.Connect();
	}
}

void CVctestDlg::OnSelchangeComboChannel() 
{
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_CHANNEL);
	m_vitCtrl1.SetCurrentControlCam(pBox->GetCurSel() + 1);

	// reconnect the connection with new video channel
	if (m_vitCtrl1.GetControlStatus() != 0 && 
		m_vitCtrl1.GetControlStatus() != 3)
	{
		m_vitCtrl1.Disconnect();
		m_vitCtrl1.Connect();
	}	
}

void CVctestDlg::OnCheckForceGdi() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_FORCE_GDI);
	m_vitCtrl1.SetForceGDI(pBut->GetCheck());
}

void CVctestDlg::OnCheckGdiStretchblt() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_GDI_STRETCHBLT);
	m_vitCtrl1.SetGDIUseStretchBlt(pBut->GetCheck());
}

void CVctestDlg::OnCheckDdrawOnepass() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_DDRAW_ONEPASS);
	m_vitCtrl1.SetDDrawOnePass(pBut->GetCheck());	
}

void CVctestDlg::OnCheckIgnoreBorder() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_IGNORE_BORDER);
	m_vitCtrl1.SetIgnoreBorder(pBut->GetCheck());	
}

void CVctestDlg::OnCheckIgnoreCaption() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_IGNORE_CAPTION);
	m_vitCtrl1.SetIgnoreCaption(pBut->GetCheck());	
}

void CVctestDlg::OnCheckDeblock() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_DEBLOCK);
	m_vitCtrl1.SetDeblocking(pBut->GetCheck());		
}

void CVctestDlg::OnCheckDisplay() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_DISPLAY);
	m_vitCtrl1.SetDisplay(pBut->GetCheck());	
}

void CVctestDlg::SetCtrlButtonState(DWORD dwIndex, BOOL bVisible)
{
	long nVal = m_vitCtrl1.GetControlButtonOpts();

	nVal = nVal & ~dwIndex;
	if (bVisible)
		nVal |= dwIndex;
	m_vitCtrl1.SetControlButtonOpts(nVal);
}

void CVctestDlg::OnCheckZoomEdit() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_ZOOM_EDIT);
	SetCtrlButtonState(1, pBut->GetCheck());
}

void CVctestDlg::OnCheckZoomEnabled() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_ZOOM_ENABLED);
	m_vitCtrl1.SetDigitalZoomEnabled(pBut->GetCheck());
}

void CVctestDlg::OnCheckUserdate() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_USERDATE);
	m_vitCtrl1.SetUserDateFormat(pBut->GetCheck());
}

void CVctestDlg::OnCheckStretch() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_STRETCH);
	m_vitCtrl1.SetStretch(pBut->GetCheck());	
}

void CVctestDlg::OnSelchangeComboUsrTimefmt() 
{
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_USR_TIMEFMT);
	
	m_vitCtrl1.SetDisplayTimeFormat(pBox->GetCurSel());
}

void CVctestDlg::OnButBrowse() 
{
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_SNAP_FMT);
	int nFormat = pBox->GetCurSel() + 1;

	CString strFilter;
	CString strDefExt;

	switch (nFormat)
	{
	case 1:
		strFilter = _T("Jpeg Files (*.jpg)|*.jpg|All Files (*.*)|*.*||");
		strDefExt = "jpg";
		break;
	case 2:
		strFilter = _T("BMP Files (*.bmp)|*.bmp|All Files (*.*)|*.*||");
		strDefExt = "bmp";
		break;
	case 3:
		strFilter = _T("YUY2 Files (*.yuv)|*.yuv|All Files (*.*)|*.*||");
		strDefExt = "yuv";
		break;
	case 4:
		strFilter = _T("RGB24 Files (*.rgb)|*.rgb|All Files (*.*)|*.*||");
		strDefExt = "rgb";
		break;
	case 5:
		strFilter = _T("IYUV Files (*.yuv)|*.yuv|All Files (*.*)|*.*||");
		strDefExt = "yuv";
		break;
	case 6:
		strFilter = _T("YU12 Files (*.yuv)|*.yuv|All Files (*.*)|*.*||");
		strDefExt = "yuv";
		break;
	}

	CFileDialog dlgFileSaveAs(FALSE, strDefExt, NULL, OFN_HIDEREADONLY |
		OFN_OVERWRITEPROMPT, strFilter);

	dlgFileSaveAs.m_ofn.hwndOwner = m_hWnd;
	CString strName;
	GetDlgItem(IDC_FILENAME)->GetWindowText(strName);

	dlgFileSaveAs.m_ofn.lpstrFile = strName.GetBuffer(MAX_PATH);
	
	if (dlgFileSaveAs.DoModal() != IDOK)
	{
		strName.ReleaseBuffer();
		return;
	}
	strName.ReleaseBuffer();

	GetDlgItem(IDC_FILENAME)->SetWindowText(strName);
}

void CVctestDlg::OnSave() 
{
	CString strName;
	GetDlgItem(IDC_FILENAME)->GetWindowText(strName);

	if (strName.IsEmpty())
	{
		MessageBox("Please specify file name before saving");
		return;
	}

	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_SNAP_FMT);
	int nFormat = pBox->GetCurSel() + 1;
	long lRet = m_vitCtrl1.SaveSnapshot(nFormat, strName);
	strName = "";
}

char g_szPermittedCmd[] = "0123456789abcdefABCDEF,";

bool CVctestDlg::CheckComCommand()
{
	CString strComCmd;

	((CEdit *) GetDlgItem(IDC_EDIT_COMCMD))->GetWindowText(strComCmd);
	if (strComCmd.GetLength() == 0)
	{
		MessageBox("Command should not be empty");
		return false;
	}

	int nLen = strlen(g_szPermittedCmd);

	for (int nCnt = 0; nCnt < strComCmd.GetLength(); nCnt++)
	{
		char cNow = strComCmd.GetAt(nCnt);
		bool bFound = false;
		for (int nCnt2 = 0; nCnt2 < nLen; nCnt2++)
		{
			if (g_szPermittedCmd[nCnt2] == cNow)
			{
				bFound = true;
				break;
			}
		}

		if (!bFound)
		{
			CString strMsg;
			strMsg.Format("COM command contains some forbidden letters, the permitted letters are: %s",
				g_szPermittedCmd);
			MessageBox(strMsg);
			return false;
		}
	}

	return true;
}

void CVctestDlg::OnButSendComcmd() 
{
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_UART_PORT);
	CComboBox *pBoxSVTP = (CComboBox *) GetDlgItem(IDC_COMBO_SERVER_TYPE);

	int nPort = 1;
	CString strComCmd;

	((CEdit *) GetDlgItem(IDC_EDIT_COMCMD))->GetWindowText(strComCmd);

	if (!CheckComCommand())
		return;

	if (pBoxSVTP->GetCurSel() == 4)
	{
		nPort = pBox->GetCurSel() + 1;
	}

	m_vitCtrl1.SendUartCommand(strComCmd, TRUE, nPort);	
}

void CVctestDlg::OnButReadComcmd() 
{
	int nPort = 1;
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_UART_PORT);
	CComboBox *pBoxSVTP = (CComboBox *) GetDlgItem(IDC_COMBO_SERVER_TYPE);

	if (pBoxSVTP->GetCurSel() == 4)
	{
		nPort = pBox->GetCurSel() + 1;
	}

	CComBSTR strRead;
	CComVariant varVal;
	m_vitCtrl1.GetUartData(&varVal, 6, nPort, 1000);
	strRead = varVal.bstrVal;
	GetDlgItem(IDC_EDIT_COMCMD)->SetWindowText(CString(strRead));	
}

void CVctestDlg::OnButtonDbpathBrowse() 
{
	BROWSEINFO biShell;
	char szFolderName[MAX_PATH];
    LPITEMIDLIST pidlSelected = NULL;
    LPMALLOC pMalloc = NULL;
	DWORD dwLocNum = 0;

	// Select Database Folder
    SHGetMalloc(&pMalloc);
    biShell.hwndOwner       = m_hWnd;
    biShell.pidlRoot        = NULL;
    biShell.pszDisplayName  = szFolderName;
    biShell.lpszTitle       = "Select database path";
    biShell.ulFlags         = BIF_BROWSEFORCOMPUTER | BIF_DONTGOBELOWDOMAIN | BIF_RETURNFSANCESTORS |
                              BIF_RETURNONLYFSDIRS;// | BIF_NONEWFOLDERBUTTON | BIF_USENEWUI;
    biShell.lpfn            = NULL;
    biShell.lParam          = 0;
    biShell.iImage          = 0;
 
    if ((pidlSelected = SHBrowseForFolder(&biShell)) == NULL)
        return;

    if (!SHGetPathFromIDList(pidlSelected, szFolderName))
	{
		if (pidlSelected)
			pMalloc->Free(pidlSelected);
		return;
	}

    if (pidlSelected)
		pMalloc->Free(pidlSelected);
    pMalloc->Release();

	GetDlgItem(IDC_EDIT_DBPATH)->SetWindowText(szFolderName);
}

void CVctestDlg::StartDatabaseRecord(BOOL bOnlyWhenRecording) 
{
	CString strName;

	GetDlgItem(IDC_BUTTON_RECORD)->GetWindowText(strName);	
	if (strName.Compare("Start Record") == 0 && bOnlyWhenRecording)
		return;

	BOOL bEvent;
	
	bEvent = FALSE;
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_EVENT_RECORD);

	if (pBut->GetCheck())
	{
		bEvent = TRUE;
	}

	if (strName.Compare("Start Record") == 0 || bOnlyWhenRecording)
	{
		CString strDbPath, strLocation;

		GetDlgItem(IDC_EDIT_DBPATH)->GetWindowText(strDbPath);
		GetDlgItem(IDC_EDIT_LOCATION)->GetWindowText(strLocation);

		if (strDbPath.GetLength() > 0 && strLocation.GetLength() > 0)
		{
			long lRet;
			lRet = m_vitCtrl1.SetDatabasePath(strDbPath, TRUE);
			if (lRet != 0)
			{
				GetDlgItem(IDC_BUTTON_RECORD)->EnableWindow(FALSE);
				m_vitCtrl1.RepairDatabase(strDbPath);
				return;
			}

			lRet = m_vitCtrl1.SetLocation(strLocation, TRUE);
			if (lRet != 0)
			{
				GetDlgItem(IDC_BUTTON_RECORD)->EnableWindow(FALSE);
				m_vitCtrl1.RepairLocation(strLocation);
				return;
			}
			
			lRet = m_vitCtrl1.StartMediaRecordEx(3, bEvent);	// 3 is audio/video

			if (lRet == 0)
			{
				GetDlgItem(IDC_BUTTON_RECORD)->SetWindowText("Stop Rec");	
			}
			else
			{
				strName.Format("Error to start recording, error code is: %d", lRet);
				MessageBox(strName);
			}
		}
	}
	else
	{
		m_vitCtrl1.StopMediaRecord();
		GetDlgItem(IDC_BUTTON_RECORD)->SetWindowText("Start Record");
	}
}

void CVctestDlg::OnCheckEventRecord() 
{
	StartDatabaseRecord(TRUE);
}

void CVctestDlg::OnButtonRecord() 
{
	StartDatabaseRecord(FALSE);	
}

void CVctestDlg::OnCheckEventMd() 
{
	SetEventType();
}

void CVctestDlg::OnCheckEventDi1rise() 
{
	SetEventType();
}

void CVctestDlg::OnCheckEventDi1fall() 
{
	SetEventType();
}

void CVctestDlg::OnCheckEventDi1high() 
{
	SetEventType();
}

void CVctestDlg::OnCheckEventDi1low() 
{
	SetEventType();
}

void CVctestDlg::OnCheckEventDi2rise() 
{
	SetEventType();	
}

void CVctestDlg::OnCheckEventDi3fall() 
{
	SetEventType();	
}

void CVctestDlg::OnCheckEventDi4high() 
{
	SetEventType();	
}

void CVctestDlg::DoHttpOperation(BOOL bPost)
{
	CString strHttpCmd;
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_SHOW_RETURN);

	GetDlgItem(IDC_EDIT_HTTP_CMD)->GetWindowText(strHttpCmd);

	if (strHttpCmd.GetLength() <= 0)
	{
		MessageBox("Url command could not be empty");
		return;
	}
  
	CComVariant varRet;

    long lRet = m_vitCtrl1.HttpCommand(strHttpCmd, bPost, pBut->GetCheck(), &varRet);
    
    if (lRet != 0)
	{
		CString strMsg;

		strMsg.Format("Failed with error %d", lRet);
        MessageBox(strMsg);
	}
    
    if (pBut->GetCheck())
	{
		CString strMsg = varRet.bstrVal;
        MessageBox(strMsg);
	}
    else
        MessageBox("Command sent successfully");
}

void CVctestDlg::OnButtonHttpPost() 
{
	DoHttpOperation(TRUE);
}

void CVctestDlg::OnButtonHttpGet() 
{
	DoHttpOperation(FALSE);
}

void CVctestDlg::OnChkAviShow() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHK_AVI_SHOW);

	SetCtrlButtonState(2, pBut->GetCheck());
}

void CVctestDlg::OnButAviStart() 
{
	if (m_vitCtrl1.GetAVIStatus() != 2)
	{
		// start recording
		m_vitCtrl1.StartAVIConversion();
	}
	else
	{
		m_vitCtrl1.StopAVIConversion();
	}
	
}

void CVctestDlg::OnChkAviAutoset() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHK_AVI_AUTOSET);

	m_vitCtrl1.SetAutoAVISettings(pBut->GetCheck());
	SetAVIButtonStatus();
}

void CVctestDlg::OnChkAviAutosize() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHK_AVI_AUTOSIZE);

	m_vitCtrl1.SetAVIVideoSizeByStream(pBut->GetCheck());
	SetAVIButtonStatus();	
}

void CVctestDlg::OnButAviUpdset() 
{
	int nW, nH;

	// update FR, W, H
	CString strVal;

	GetDlgItem(IDC_EDIT_AVI_VFR)->GetWindowText(strVal);
	m_vitCtrl1.SetAVIVideoFrameRate(atoi(strVal));

	GetDlgItem(IDC_EDIT_AVI_W)->GetWindowText(strVal);
	nW = atoi(strVal);
	GetDlgItem(IDC_EDIT_AVI_H)->GetWindowText(strVal);
	nH = atoi(strVal);
	if ((nW % 8) != 0)
	{
		nW -= (nW % 8);
		strVal.Format("%d", nW);
		GetDlgItem(IDC_EDIT_AVI_W)->SetWindowText(strVal);
	}

	if ((nH % 8) != 0)
	{
		nH -= (nH % 8);
		strVal.Format("%d", nH);
		GetDlgItem(IDC_EDIT_AVI_H)->SetWindowText(strVal);
	}
	m_vitCtrl1.SetAVIVideoWidth(nW);
	m_vitCtrl1.SetAVIVideoHeight(nH);
	
}

void CVctestDlg::OnButAviVcomp() 
{
	m_vitCtrl1.ChooseAVIVideoCompressor("Video Compressor");
}

void CVctestDlg::OnButAviAcomp() 
{
	m_vitCtrl1.ChooseAVIAudioCompressor("Audio Compressor");
}

void CVctestDlg::OnChkTestInput() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHK_TEST_INPUT);
	bool bNotify = pBut->GetCheck()?true:false;

	m_vitCtrl1.SetNotifyAudioPacket(bNotify);
	m_vitCtrl1.SetNotifyVideoPacket(bNotify);
	
	if (bNotify)
	{
    	m_vitCtrl2.StartPacketInput(m_vitCtrl1.GetCurrentMediaType());
    	m_vitCtrl2.SetRemoteIPAddr("From Proxy");
	}
	else
	{
    	m_vitCtrl2.StopPacketInput();
	}
	
}

void CVctestDlg::OnButSetRefresh() 
{
	long lRet;

	CString strServIP, strRootPwd, strUserName, strTemp;

	GetDlgItem(IDC_EDIT_SERV_IP)->GetWindowText(strServIP);
	GetDlgItem(IDC_EDIT_PORT)->GetWindowText(strTemp);
	GetDlgItem(IDC_EDIT_ROOT_ID)->GetWindowText(strUserName);
	GetDlgItem(IDC_EDIT_ROOT_PWD)->GetWindowText(strRootPwd);

	m_vitCtrl1.SetPassword(strRootPwd);
	m_vitCtrl1.SetUserName(strUserName);
	m_vitCtrl1.SetRemoteIPAddr(strServIP);
	long lPort = atoi(strTemp);
	if (lPort <= 0 || lPort > 65535)
		lPort = 80;
	m_vitCtrl1.SetHttpPort(lPort);

	lRet = m_vitCtrl1.RefreshServerConfig();

	if (lRet != 0)
	{
		strTemp.Format("Could not refresh config: %d", lRet);
		MessageBox(strTemp);
		return;
	}
	UpdateServerSetStatus(true);
	OnButSetRead();
}

void CVctestDlg::OnButSetRead() 
{
	CString strSec;
	CString strEntry;
	CString strTemp;

	GetDlgItem(IDC_EDIT_SET_INDEX)->GetWindowText(strTemp);
	int lIndex = atoi(strTemp);

	strSec = m_vitCtrl1.GetServerConfigSection(lIndex);
	strEntry = m_vitCtrl1.GetServerConfigEntry(lIndex);
	if (strEntry == "")
	{
		GetDlgItem(IDC_EDIT_SET_SECENTRY)->SetWindowText("No Such item");
		GetDlgItem(IDC_EDIT_SET_VALUE)->SetWindowText("");
	}
	else
	{
		strTemp.Format("%s/%s", strSec, strEntry);
		GetDlgItem(IDC_EDIT_SET_SECENTRY)->SetWindowText(strTemp);
		GetDlgItem(IDC_EDIT_SET_VALUE)->SetWindowText(m_vitCtrl1.GetServerConfig(lIndex, 0));
	}	
}

void CVctestDlg::OnButSetSet() 
{
	CString strTemp, strVal;
	long lRet;

	GetDlgItem(IDC_EDIT_SET_INDEX)->GetWindowText(strTemp);
	GetDlgItem(IDC_EDIT_SET_VALUE)->GetWindowText(strVal);
	int lIndex = atoi(strTemp);


	lRet = m_vitCtrl1.SetServerConfig(lIndex, 0, strVal);

	if (lRet != 0)
	{
		strTemp.Format("SetServerConfig cfg failed: %d", lRet);
		MessageBox(strTemp);
	}
}

void CVctestDlg::OnButSetUpd() 
{
	CString strTemp;
	long lRet;

	lRet = m_vitCtrl1.UpdateServerConfig();

	if (lRet != 0)
	{
		strTemp.Format("Update server cfg failed: %d", lRet);
		MessageBox(strTemp);
	}
}

void CVctestDlg::OnButDatetimeSet() 
{
	CString strTemp, strDate, strTime;
	long lRet;

	GetDlgItem(IDC_EDIT_DATETIME_DATE)->GetWindowText(strDate);
	GetDlgItem(IDC_EDIT_DATETIME_TIME)->GetWindowText(strTime);

	if (strDate.IsEmpty())
	{
		MessageBox("must give server date");
		return;
	}

	if (strTime.IsEmpty())
	{
		MessageBox("must give server time");
		return;
	}

	lRet = m_vitCtrl1.SetServerDateTime(strDate, strTime);
	if (lRet != 0)
	{
		strTemp.Format("Set server date/time error: %d", lRet);
		MessageBox(strTemp);
	}
	
}

BEGIN_EVENTSINK_MAP(CVctestDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CVctestDlg)
	ON_EVENT(CVctestDlg, IDC_VITAMINCTRL1, 2 /* OnConnectionBroken */, OnOnConnectionBrokenVitaminctrl1, VTS_I4)
	ON_EVENT(CVctestDlg, IDC_VITAMINCTRL1, 5 /* OnConnectionOK */, OnOnConnectionOKVitaminctrl1, VTS_I4)
	ON_EVENT(CVctestDlg, IDC_VITAMINCTRL1, 3 /* OnNewAudioPiece */, OnOnNewAudioPieceVitaminctrl1, VTS_PVARIANT)
	ON_EVENT(CVctestDlg, IDC_VITAMINCTRL1, 6 /* OnRecordStatus */, OnOnRecordStatusVitaminctrl1, VTS_I4 VTS_I4)
	ON_EVENT(CVctestDlg, IDC_VITAMINCTRL1, 7 /* OnMDAlert */, OnOnMDAlertVitaminctrl1, VTS_PVARIANT)
	ON_EVENT(CVctestDlg, IDC_VITAMINCTRL1, 8 /* OnDIDOAlert */, OnOnDIDOAlertVitaminctrl1, VTS_I4 VTS_I4)
	ON_EVENT(CVctestDlg, IDC_VITAMINCTRL1, 9 /* OnNewVideo */, OnOnNewVideoVitaminctrl1, VTS_BOOL VTS_BOOL VTS_PVARIANT)
	ON_EVENT(CVctestDlg, IDC_VITAMINCTRL1, 10 /* OnNewPacket */, OnOnNewPacketVitaminctrl1, VTS_BOOL VTS_PVARIANT)
	ON_EVENT(CVctestDlg, IDC_VITAMINCTRL1, 11 /* OnAVIStatus */, OnOnAVIStatusVitaminctrl1, VTS_I4)
	ON_EVENT(CVctestDlg, IDC_VITAMINCTRL1, 13 /* OnServerModelType */, OnOnServerModelTypeVitaminctrl1, VTS_I4)
	ON_EVENT(CVctestDlg, IDC_VITAMINCTRL1, 14, OnRequestAVIFileNameVitaminctrl1, VTS_PVARIANT)
	//}}AFX_EVENTSINK_MAP
//	ON_EVENT(CVctestDlg, IDC_VITAMINCTRL1, 14, OnRequestAVIFileNameVitaminctrl1, VTS_PVARIANT)
//ON_EVENT(CVctestDlg, IDC_VITAMINCTRL1, 14, OnRequestAVIFileNameVitaminctrl1, VTS_PVARIANT)
END_EVENTSINK_MAP()

void CVctestDlg::OnOnConnectionBrokenVitaminctrl1(long eConnType) 
{
	GetDlgItem(IDC_EDIT_SERV_IP)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_PORT)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_ROOT_ID)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_ROOT_PWD)->EnableWindow(TRUE);
	// sam 2007/05/18
	((CButton *) GetDlgItem(IDC_CHECK_TWOWAYAUDIO))->SetCheck(0);
	m_vitCtrl1.SetEnableTwoWayAudio(0);

	GetDlgItem(IDC_CHECK_TWOWAYAUDIO)->EnableWindow(FALSE);	
	GetDlgItem(IDC_BUTTON_CONN)->SetWindowText("Start");

	ResetControls(false);
}

void CVctestDlg::OnOnConnectionOKVitaminctrl1(long eConnType) 
{
	GetDlgItem(IDC_EDIT_SERV_IP)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_PORT)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_ROOT_ID)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_ROOT_PWD)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_CONN)->SetWindowText("Stop");	
	ResetControls(true);
	m_lImgNum = 0;
	m_lNoSignalImgNum = 0;
	m_lMDAlertNum = 0;
}

void CVctestDlg::OnOnMDAlertVitaminctrl1(VARIANT FAR* pvPiece) 
{
	if (pvPiece->vt != (VT_ARRAY | VT_VARIANT)) 
	{
		MessageBox("Data type incorrect!", "Error", MB_OK | MB_ICONERROR);
		return;
	}

	long Dims = SafeArrayGetDim(pvPiece->parray);
	if (Dims != 2)
	{
		MessageBox("Array dimension incorrect!", "Error", MB_OK | MB_ICONERROR);
		return;
	}

	long lUpperBounds;
	long lLowerBounds;
	SafeArrayGetLBound(pvPiece->parray, 1, &lLowerBounds);
	SafeArrayGetUBound(pvPiece->parray, 1, &lUpperBounds);

	int nSize = lUpperBounds - lLowerBounds + 1;
	if (nSize != 3)
	{
		MessageBox("Return array incorrect", "Error", MB_OK | MB_ICONERROR);
		return;
	}

	SafeArrayGetLBound(pvPiece->parray, 2, &lLowerBounds);
	SafeArrayGetUBound(pvPiece->parray, 2, &lUpperBounds);
	nSize = lUpperBounds - lLowerBounds + 1;
	if (nSize != 2)
	{
		MessageBox("Return array incorrect", "Error", MB_OK | MB_ICONERROR);
		return;
	}
	m_lMDAlertNum++;

	CComVariant varCom;
	USES_CONVERSION;
	CString strMsg;
	CString strTot;
	long alIndex[2];
	for (int nCnt = 0; nCnt <= nSize; nCnt++)
	{
		varCom = (VARIANT_BOOL) VARIANT_FALSE;
		alIndex[0] = nCnt;
		alIndex[1] = 0; 
		HRESULT hresult = SafeArrayGetElement(pvPiece->parray, alIndex, &varCom);
		if (FAILED(hresult))
			break;

		if (varCom.boolVal)
		{
			alIndex[1] = 1; 
			HRESULT hresult = SafeArrayGetElement(pvPiece->parray, alIndex, &varCom);
			if (FAILED(hresult))
				break;
			strMsg.Format("W%d(%d)", nCnt + 1, varCom.lVal);
			if (strTot.GetLength() > 0)
				strTot += ", ";
			strTot += strMsg;
		}
	}
	GetDlgItem(IDC_EDIT_MD_CONTENT)->SetWindowText(strTot);
	strMsg.Format("%d", m_lMDAlertNum);
	GetDlgItem(IDC_EDIT_MD_NUM)->SetWindowText(strMsg);	
}

void CVctestDlg::Handle4ChDIDOAlert(long lValue)
{
	long lDI, lDO;
	long lSrcDI, lSrcDO;
	long i, lMask;

	lSrcDI = (lValue & 0xFFFF);
	lSrcDO = (lValue >> 16);
	lDI = (lValue & 0xFFFF);
	lDO = (lValue >> 16);

	lMask = 1;
	for (i = 0; i < 4; i++)
	{
		if ((lSrcDI & lMask) == lMask)
		{
			if ((lDI & lMask) != 0)
			{
				GetDlgItem(IDC_EDIT_4CH_DIIMG1 + i)->SetWindowText("H");
			}
			else
			{
				GetDlgItem(IDC_EDIT_4CH_DIIMG1 + i)->SetWindowText("L");
			}
		}
		lMask <<= 1;
	}

	lMask = 1;
	for (i = 0; i < 2; i++)
	{
		if ((lSrcDO & lMask) != 0)
		{
			if ((lDO & lMask) != 0)
				GetDlgItem(IDC_EDIT_4CH_DOIMG1 + i)->SetWindowText("H");
			else
				GetDlgItem(IDC_EDIT_4CH_DOIMG1 + i)->SetWindowText("L");
		}
		lMask <<= 1;
	}
}

void CVctestDlg::OnOnDIDOAlertVitaminctrl1(long lChangeFlag, long lValue) 
{
    long lDI = (lValue & 0xFFFF);
    long lDO = (lValue >> 16);

	CWnd *pDI = GetDlgItem(IDC_EDIT_DIIMG);
	CWnd *pDO = GetDlgItem(IDC_EDIT_DOIMG);
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_SERVER_TYPE);
    
	if (pBox->GetCurSel() == 4)
	{
		Handle4ChDIDOAlert(lValue);
		return;
	}

    if (lDI & 1)
        pDI->SetWindowText("H");
    else
        pDI->SetWindowText("L");
    
    if (lDO & 1)
        pDO->SetWindowText("H");
    else
        pDO->SetWindowText("L");
}

void CVctestDlg::OnOnNewAudioPieceVitaminctrl1(VARIANT FAR* pvPiece) 
{
	long Dims = SafeArrayGetDim(pvPiece->parray);
	if (Dims != 1)
	{
		return;
	}

	long lUpperBounds;
	long lLowerBounds;
	SafeArrayGetLBound(pvPiece->parray, 1, &lLowerBounds);
	SafeArrayGetUBound(pvPiece->parray, 1, &lUpperBounds);

	int nSize = lUpperBounds - lLowerBounds + 1;
	if (nSize != 2)
	{
		return;
	}

	// the array is in 2 element, each is an array itself
	VARIANT *pbyTheBuf;
	HRESULT hresult = SafeArrayAccessData(pvPiece->parray, (void **)&pbyTheBuf);
	if (FAILED(hresult))
		return;

	SafeArrayGetLBound(pbyTheBuf[0].parray, 1, &lLowerBounds);
	SafeArrayGetUBound(pbyTheBuf[0].parray, 1, &lUpperBounds);
	nSize = lUpperBounds - lLowerBounds + 1;
	if (nSize != 3)
	{
		SafeArrayUnaccessData(pvPiece->parray);
		return;
	}

	CComVariant varCom;
	long lIndex = 0;
	hresult = SafeArrayGetElement(pbyTheBuf[0].parray, &lIndex, &varCom);
	if (FAILED(hresult))
	{
		SafeArrayUnaccessData(pvPiece->parray);
		return;
	}

	long lSec = varCom.lVal;
	lIndex = 1;
	hresult = SafeArrayGetElement(pbyTheBuf[0].parray, &lIndex, &varCom);
	if (FAILED(hresult))
	{
		SafeArrayUnaccessData(pvPiece->parray);
		return;
	}

	CString strTemp;
	strTemp.Format("%d.%03d", lSec, varCom.lVal);
	GetDlgItem(IDC_EDIT_ADEC_TIME)->SetWindowText(strTemp);

	lIndex = 2;
	hresult = SafeArrayGetElement(pbyTheBuf[0].parray, &lIndex, &varCom);
	SafeArrayUnaccessData(pvPiece->parray);
	if (FAILED(hresult))
	{
		return;
	}

	m_dwDecodedAudioSize += varCom.lVal;
	strTemp.Format("%ld", m_dwDecodedAudioSize);
	GetDlgItem(IDC_EDIT_ADEC_SIZE)->SetWindowText(strTemp);	
}

void CVctestDlg::OnOnNewVideoVitaminctrl1(BOOL bSignal, BOOL bDecodedImg, VARIANT FAR* pvPiece) 
{
	CString strTemp;

	m_lImgNum++;
	if (!bSignal)
	{
		m_lNoSignalImgNum++;
	}

	strTemp.Format("%d", m_lImgNum);
	GetDlgItem(IDC_EDIT_IMAGE_NUM)->SetWindowText(strTemp);

	strTemp.Format("%d", m_lNoSignalImgNum);
	GetDlgItem(IDC_EDIT_NO_SIGNAL_NUM)->SetWindowText(strTemp);

	long Dims = SafeArrayGetDim(pvPiece->parray);
	if (Dims != 1)
	{
		return;
	}

	// the array is in 2 element, each is an array itself
	VARIANT *pbyTheBuf;
	HRESULT hresult = SafeArrayAccessData(pvPiece->parray, (void **)&pbyTheBuf);
	if (FAILED(hresult))
		return;

	long lUpperBounds;
	long lLowerBounds;
	SafeArrayGetLBound(pbyTheBuf[0].parray, 1, &lLowerBounds);
	SafeArrayGetUBound(pbyTheBuf[0].parray, 1, &lUpperBounds);
	int nSize = lUpperBounds - lLowerBounds + 1;
	if (nSize != 3)
	{
		SafeArrayUnaccessData(pvPiece->parray);
		return;
	}

	CComVariant varCom;
	long lIndex = 0;
	hresult = SafeArrayGetElement(pbyTheBuf[0].parray, &lIndex, &varCom);
	if (FAILED(hresult))
	{
		SafeArrayUnaccessData(pvPiece->parray);
		return;
	}

	long lSec = varCom.lVal;
	lIndex = 1;
	hresult = SafeArrayGetElement(pbyTheBuf[0].parray, &lIndex, &varCom);
	if (FAILED(hresult))
	{
		SafeArrayUnaccessData(pvPiece->parray);
		return;
	}

	strTemp.Format("%d.%03d", lSec, varCom.lVal);
	GetDlgItem(IDC_EDIT_VDEC_TIME)->SetWindowText(strTemp);

	if (!bDecodedImg)
	{
		SafeArrayUnaccessData(pvPiece->parray);
		return;
	}

	lIndex = 2;
	hresult = SafeArrayGetElement(pbyTheBuf[0].parray, &lIndex, &varCom);
	if (FAILED(hresult))
	{
		SafeArrayUnaccessData(pvPiece->parray);
		return;
	}

	m_dwDecodedVideoSize += varCom.lVal;
	strTemp.Format("%ld", m_dwDecodedVideoSize);
	GetDlgItem(IDC_EDIT_VDEC_SIZE)->SetWindowText(strTemp);	


	CString strExt;

	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_VIDEODEC_FMT);
	if (pBox->GetCurSel() == 0)
        strExt = ".jpg";
	else if (pBox->GetCurSel() == 1)
		strExt = ".bmp";
	else if (pBox->GetCurSel() == 1)
		strExt = ".yu2";
	else
        strExt = ".raw";

    strTemp = "c:\\video";
	strTemp += strExt;

	FILE *pFile = fopen(strTemp, "wb");
	if (pFile)
	{
		BYTE *pbyBuf;

		HRESULT hr = SafeArrayAccessData(pbyTheBuf[1].parray, (void **)&pbyBuf);
		if (!FAILED(hr))
		{
			fwrite(pbyBuf, 1, varCom.lVal, pFile);
			SafeArrayUnaccessData(pbyTheBuf[1].parray);
		}
		fclose(pFile);
	}
	SafeArrayUnaccessData(pvPiece->parray);	
}

void CVctestDlg::OnOnRecordStatusVitaminctrl1(long lStatusCode, long lParam) 
{
	if (lStatusCode == 1)
	{
		return;
	}
	else if (lStatusCode == 2)
	{
		if (lParam == 0)
		{
			MessageBox("Repair database failed");
			return;
		}
		GetDlgItem(IDC_BUTTON_RECORD)->EnableWindow(TRUE);
	}
	else if (lStatusCode == 3)
	{
		if (lParam == 0)
		{
			MessageBox("Repair location failed");
			return;
		}
		GetDlgItem(IDC_BUTTON_RECORD)->EnableWindow(TRUE);
	}	
	
}

void CVctestDlg::OnOnNewPacketVitaminctrl1(BOOL bVideo, VARIANT FAR* pvPiece) 
{
	long Dims = SafeArrayGetDim(pvPiece->parray);
	if (Dims != 1)
	{
		return;
	}

	long lUpperBounds;
	long lLowerBounds;
	SafeArrayGetLBound(pvPiece->parray, 1, &lLowerBounds);
	SafeArrayGetUBound(pvPiece->parray, 1, &lUpperBounds);

	int nSize = lUpperBounds - lLowerBounds + 1;
	if (nSize != 2)
	{
		return;
	}
	
	
	// the array is in 2 element, each is an array itself
	VARIANT *pbyTheBuf;
	HRESULT hresult = SafeArrayAccessData(pvPiece->parray, (void **)&pbyTheBuf);
	if (FAILED(hresult))
		return;

	SafeArrayGetLBound(pbyTheBuf[0].parray, 1, &lLowerBounds);
	SafeArrayGetUBound(pbyTheBuf[0].parray, 1, &lUpperBounds);
	nSize = lUpperBounds - lLowerBounds + 1;
	if (nSize != 3)
	{
		SafeArrayUnaccessData(pvPiece->parray);
		return;
	}

	CComVariant varCom;
	long lIndex = 2;
	hresult = SafeArrayGetElement(pbyTheBuf[0].parray, &lIndex, &varCom);
	if (FAILED(hresult))
	{
		SafeArrayUnaccessData(pvPiece->parray);
		return;
	}

	nSize = varCom.lVal;

	m_vitCtrl2.InputMediaPacket(nSize, &pbyTheBuf[1]);
	SafeArrayUnaccessData(pvPiece->parray);	
	
}

void CVctestDlg::OnOnAVIStatusVitaminctrl1(long eStatus) 
{
	if (eStatus == 2)
	{
		GetDlgItem(IDC_BUT_AVI_START)->SetWindowText("Stop");
	}
	else
	{
		GetDlgItem(IDC_BUT_AVI_START)->SetWindowText("Start");
	}	
}

bool CVctestDlg::CheckPresetName()
{
	CString strPresetName;

	GetDlgItem(IDC_EDIT_PRESET)->GetWindowText(strPresetName);
	if (strPresetName.GetLength() == 0)
	{
		MessageBox("Preset name should not be empty");
		return false;
	}

	if (strPresetName.Find(" ", 0) != -1)
	{
		MessageBox("Preset name should not contains space");
		return false;
	}

	return true;
}

void CVctestDlg::OnButSavePreset() 
{
	CString strPresetName;

	GetDlgItem(IDC_EDIT_PRESET)->GetWindowText(strPresetName);

	if (!CheckPresetName())
		return;

	if (m_vitCtrl1.SavePresetPosition(strPresetName) == 0)
	{
		UpdatePresetLocation();
	}
}

void CVctestDlg::OnChangeEditJpgInterval() 
{
	CString strVal;

	GetDlgItem(IDC_EDIT_JPG_INTERVAL)->GetWindowText(strVal);

	if (strVal.GetLength() != 0)
	{
		m_vitCtrl1.SetJpegSecsPerFrame(atoi(strVal));
	}	
}

void CVctestDlg::OnCheckVolctrl() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_VOLCTRL);
	SetCtrlButtonState(16, pBut->GetCheck());	
}

void CVctestDlg::OnCheckMicctrl() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_MICCTRL);
	SetCtrlButtonState(32, pBut->GetCheck());	
}

void CVctestDlg::OnCheckTalkBtn() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_TALK_BTN);
	SetCtrlButtonState(4, pBut->GetCheck());	
}

void CVctestDlg::OnCheckDecodeav() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_DECODEAV);
	m_vitCtrl1.SetDecodeAV(pBut->GetCheck());
}

void CVctestDlg::OnCheckMotionFrm() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_MOTION_FRM);
	m_vitCtrl1.SetDisplayMotionFrame(pBut->GetCheck());	
}

void CVctestDlg::OnChangeEditDisplayPeriod() 
{
	CString strVal;

	GetDlgItem(IDC_EDIT_DISPLAY_PERIOD)->GetWindowText(strVal);

	if (strVal.GetLength() > 0)
	{
		int nVal = atoi(strVal);

		m_vitCtrl1.SetDisplayPeriod(nVal);
	}
}

void CVctestDlg::OnButCust1() 
{
	m_vitCtrl1.SendCameraCommand("cust1", 3000);
}

void CVctestDlg::OnButCust2() 
{
	m_vitCtrl1.SendCameraCommand("cust2", 3000);
}

void CVctestDlg::OnButCust3() 
{
	m_vitCtrl1.SendCameraCommand("cust3", 3000);
}

void CVctestDlg::OnButCust4() 
{
	m_vitCtrl1.SendCameraCommand("cust4", 3000);
}

void CVctestDlg::OnButIrisauto() 
{
	m_vitCtrl1.SendCameraCommand("irisauto", 3000);
}

void CVctestDlg::OnButIrisclose() 
{
	m_vitCtrl1.SendCameraCommand("close", 3000);
}

void CVctestDlg::OnButIrisopen() 
{
	m_vitCtrl1.SendCameraCommand("open", 3000);
}

void CVctestDlg::OnCheckForceNonyuv() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_FORCE_NONYUV);
	m_vitCtrl1.SetForceNonYUV(pBut->GetCheck());		
}

void CVctestDlg::OnCheckAutoServermodel() 
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_AUTO_SERVERMODEL);
	m_vitCtrl1.SetAutoServerModelType(pBut->GetCheck());			
}

void CVctestDlg::OnOnServerModelTypeVitaminctrl1(long eNewServerModelType) 
{
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_SERVER_TYPE);
	CComboBox *pBoxProtocol = (CComboBox *) GetDlgItem(IDC_COMBO_PROTOCOL);
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_TWOWAYAUDIO);
	
	int nLastSel = pBox->GetCurSel();

	// sam 2007/05/18
	if (eNewServerModelType == 5) // 7KDual
		pBut->EnableWindow(TRUE);
	else
		pBut->EnableWindow(FALSE);

	if (nLastSel != eNewServerModelType)
	{
		pBox->SetCurSel(eNewServerModelType);
		ChangeUIItems(eNewServerModelType, false);
		// sam 2007/05/02
		if (eNewServerModelType == 0 || eNewServerModelType == 4) // 2K
			pBoxProtocol->SetCurSel(0);
		else if (eNewServerModelType == 1) // 3K
			pBoxProtocol->SetCurSel(m_vitCtrl1.GetConnectionProtocol() - 1);
		else if (eNewServerModelType == 2) // 4/5/6 K
		{
			if (m_vitCtrl1.GetConnectionProtocol() == 1)
				pBoxProtocol->SetCurSel(0);
			else
				pBoxProtocol->SetCurSel(1);
		}
		else // 7K and 7KDual
		{
			pBoxProtocol->SetCurSel(m_vitCtrl1.GetConnectionProtocol() - 1);			
		}
		
	}
}

void CVctestDlg::OnButSnapMem() 
{
	VARIANT vData, vInfo;
	
	long lRet = m_vitCtrl1.GetSnapshot(1, &vData, &vInfo);

	if (vData.vt != (VT_ARRAY | VT_UI1)) 
	{
		MessageBox("Return data type incorrect!", "Error", MB_OK | MB_ICONERROR);
		VariantClear(&vData);
		VariantClear(&vInfo);
		return;
	}

	long Dims = SafeArrayGetDim(vData.parray);
	if (Dims != 1)
	{
		MessageBox("Return array dimension incorrect!", "Error", MB_OK | MB_ICONERROR);
		VariantClear(&vData);
		VariantClear(&vInfo);
		return;
	}

	long UpperBounds;
    long LowerBounds;
	SafeArrayGetLBound(vData.parray, 1, &LowerBounds);
    SafeArrayGetUBound(vData.parray, 1, &UpperBounds);

	int nSize = UpperBounds - LowerBounds + 1;
	if (nSize <= 0)
	{
		MessageBox("Return array size is 0", "Error", MB_OK | MB_ICONERROR);
		VariantClear(&vData);
		VariantClear(&vInfo);
		return;
	}

	unsigned char* buff;
	SafeArrayAccessData (vData.parray, (void**)&buff);

	// do what you want for the data in buff, it is continuous with size nSize

	FILE *pFile = fopen("c:\\mytest.bmp", "wb");
	if (pFile)
	{
		fwrite(buff, 1, nSize, pFile);
		fclose(pFile);
	}

	SafeArrayUnaccessData (vData.parray);
	VariantClear(&vData);	
	VariantClear(&vInfo);
}

void CVctestDlg::OnCbnSelchangeComboStream()
{	
	CComboBox *pBox = (CComboBox *) GetDlgItem(IDC_COMBO_STREAM);

	int nSel = pBox->GetCurSel();

	//if (nSel == 0)
	//{
 //       m_vitCtrl1.SetViewStream(2);
	//	m_vitCtrl2.SetViewStream(2);
	//}
	//else
	//{
		m_vitCtrl1.SetViewStream(nSel);
		m_vitCtrl2.SetViewStream(nSel);
	/*}*/
}

void CVctestDlg::OnBnClickedCheckTwowayaudio()
{
	CButton *pBut = (CButton *) GetDlgItem(IDC_CHECK_TWOWAYAUDIO);
	m_vitCtrl1.SetEnableTwoWayAudio(pBut->GetCheck());
}

void CVctestDlg::OnBnClickedButtonFullscreen()
{
	// TODO: Add your control notification handler code here
	m_vitCtrl1.SetFullScreen(true);
}

void CVctestDlg::OnCancel()
{
	// TODO: Add your specialized code here and/or call the base class

	CDialog::OnCancel();	
}

BOOL CVctestDlg::PreTranslateMessage(MSG* pMsg)
{
	if(pMsg->message==WM_KEYDOWN && pMsg->wParam==VK_ESCAPE)   
	{   
		return   1;   
	}   
    
	return   CDialog::PreTranslateMessage(pMsg);   
}
//void CVctestDlg::OnRequestAVIFileNameVitaminctrl1(VARIANT* pvTime)
//{
//	// TODO: Add your message handler code here
//}

void CVctestDlg::OnRequestAVIFileNameVitaminctrl1(VARIANT* pvTime)
{
	// TODO: Add your message handler code here
	m_vitCtrl1.SetAVIFilePathName("c:/record/vctest.avi");
}
